
from django.apps import AppConfig
import datetime

from django.conf import settings

from djangotools.common import iter_module
from djangotools import config

class BaseDjangoToolsApp(AppConfig):
    default = False
    def __init__(self, app_name, app_module):
        super().__init__(app_name, app_module)
        if hasattr(self, "on_all_apps_ready"):
            config.add_on_all_app_ready_callback(self.on_all_apps_ready)

class DjangoToolsAppConfig(AppConfig):
    name = 'djangotools'
    _is_ready = False


    def _load_context(self):
        from djangotools.views.context import base
        base.load_modules()

    def _load_views(self):
        for module in iter_module(settings.VIEWS_MODULES): pass

    def _init(self):
        self._load_context()
        self._load_views()

    def on_all_apps_ready(self):
        if not self._is_ready:
            self._init()
        self._is_ready = True


