from collections import defaultdict

from djangotools.cmdline import Command, CronManager, Argument, CommandData

from djangotools.cmdline import tasks
from djangotools.config import get_settings


class CronCommand(Command):
    NAME = "cron"
    ALIASES = ["cr"]

    HELP = "Lance le serive de cron"
    ARGUMENT = [
        Argument("options", nargs="*", help="Liste des options à passer au cron au format {CRON_NAME}.{Parameter}={Value}")
    ]
    def __init__(self):
        super().__init__()
        self.settings = get_settings()
        self.manager = CronManager(resolution=10)



        for cron in getattr(self.settings, "CRON", None) or []:
            self.manager.add_task(cron)

    def run(self, data):
        if not isinstance(data, dict):
            opt = defaultdict(CommandData)
            for x in data.options:
                left, _, value =  x.partition("=")
                cron_name, name = left.split(".")
                setattr(opt[cron_name], name, value)
        else:
            opt = data

        self.manager.schedule(opt)
