from djangotools.config.base import ConfigLoader
import os

"""
# app setting file

with NoConfigLoader():
    # si les settings appellent déja ConfigLoader
    from project.settings  import *
[...]
CONFIG = load_settings(globals())
[...]

"""
from djangotools.config.base import NoConfigLoader
settings = None
app_dir = None

def load_settings(module, base_dir=None, **kwargs):
    global settings
    global app_dir
    settings = module
    app_dir = ConfigLoader(module, base_dir, **kwargs)
    app_dir.init()
    return app_dir

loaded = False

def get_settings():
    from django.conf import settings
    return settings


_on_all_app_ready_callback = []


def add_on_all_app_ready_callback(fct):
    if fct not in _on_all_app_ready_callback:
        _on_all_app_ready_callback.append(fct)

def load_app(settings_module, app_dir=None, populate=True):
    global loaded
    if loaded: return
    loaded = True


    if app_dir:
        os.environ["APP_DIR"] = str(app_dir)

    if not "DJANGO_SETTINGS_MODULE" in os.environ:
        os.environ.setdefault('DJANGO_SETTINGS_MODULE', settings_module)

    from django.apps import apps
    from django.conf import settings

    if populate:
        apps.populate(settings.INSTALLED_APPS)
        for fct in _on_all_app_ready_callback:
            fct()